(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/asyncToGenerator'), require('@babel/runtime/regenerator')) :
    typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/asyncToGenerator', '@babel/runtime/regenerator'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.timedAudioBufferSourceNodeAudioWorklet = {}, global._asyncToGenerator, global._regeneratorRuntime));
})(this, (function (exports, _asyncToGenerator, _regeneratorRuntime) { 'use strict';

    var createConvertToContextFrame = function createConvertToContextFrame(performance) {
      return function (context, timestamp) {
        if (performance === null) {
          throw new Error('Performance is not available.');
        }
        return Math.round((context.currentTime - performance.now() / 1000 + timestamp) * context.sampleRate);
      };
    };

    var createPerformance = function createPerformance() {
      return typeof window === 'undefined' ? null : typeof window.performance === 'undefined' ? null : window.performance;
    };

    var createScheduleAudioBufferSourceNode = function createScheduleAudioBufferSourceNode(convertToContextFrame) {
      return function (audioWorkletNode, context, createAudioBufferSourceNode, timingObject) {
        var audioBuffer = new AudioBuffer({
          length: 3,
          sampleRate: context.sampleRate
        });
        var audioBufferSourceNode = createAudioBufferSourceNode(context);
        var _timingObject$query = timingObject.query(),
          position = _timingObject$query.position,
          timestamp = _timingObject$query.timestamp,
          velocity = _timingObject$query.velocity;
        audioBuffer.copyToChannel(new Float32Array([position, convertToContextFrame(context, timestamp), velocity]), 0);
        audioBufferSourceNode.buffer = audioBuffer;
        var promise = new Promise(function (resolve) {
          return audioBufferSourceNode.addEventListener('ended', function () {
            return resolve();
          }, {
            once: true
          });
        });
        audioBufferSourceNode.connect(audioWorkletNode);
        audioBufferSourceNode.start();
        return promise;
      };
    };

    var createSubscribeToTimingObject = function createSubscribeToTimingObject(scheduleAudioBufferSourceNode) {
      return function (audioWorkletNode, context, createAudioBufferSourceNode, timingObject) {
        var hasPendingUpdate = false;
        var isSendingUpdate = false;
        var scheduleUpdate = function scheduleUpdate() {
          hasPendingUpdate = false;
          scheduleAudioBufferSourceNode(audioWorkletNode, context, createAudioBufferSourceNode, timingObject).then(function () {
            if (hasPendingUpdate) {
              scheduleUpdate();
            } else {
              isSendingUpdate = false;
            }
          });
        };
        var listener = function listener() {
          if (isSendingUpdate) {
            hasPendingUpdate = true;
          } else {
            isSendingUpdate = true;
            scheduleUpdate();
          }
        };
        timingObject.addEventListener('change', listener);
        return function () {
          return timingObject.removeEventListener('change', listener);
        };
      };
    };

    // This is the minified and stringified code of the timed-audio-buffer-source-node-audio-worklet-processor package.
    var worklet = "(()=>{var e={31:function(e,t,r){!function(e,t,r,o,n,u,s,i){\"use strict\";function p(e){var t=l();return function(){var r,o=s(e);if(t){var n=s(this).constructor;r=Reflect.construct(o,arguments,n)}else r=o.apply(this,arguments);return u(this,r)}}function l(){if(\"undefined\"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if(\"function\"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}var f=function(u){n(i,u);var s=p(i);function i(e){var o,n,u=e.numberOfInputs,p=e.numberOfOutputs,l=e.outputChannelCount,f=e.processorOptions;r(this,i);var a=\"object\"===t(f)&&null!==f&&\"buffer\"in f?f.buffer:null;if(!(null===a||Array.isArray(a)&&a.every((function(e){return e instanceof Float32Array}))))throw new Error(\"The buffer needs to be either null or an array with where each element is a Float32Array.\");if(1!==u)throw new Error(\"The numberOfInputs must be 1.\");if(1!==p)throw new Error(\"The numberOfOutputs must be 1.\");var c=null!==(n=null==a?void 0:a.length)&&void 0!==n?n:1;if(void 0===l||1!==l.length||c!==l[0])throw new Error(\"The outputChannelCount must match the number of channels of the buffer.\");var x=\"object\"===t(f)&&null!==f&&\"position\"in f?f.position:0;if(\"number\"!=typeof x)throw new Error('The position needs to be of type \"number\".');var d=\"object\"===t(f)&&null!==f&&\"timestamp\"in f?f.timestamp:0;if(\"number\"!=typeof d)throw new Error('The timestamp needs to be of type \"number\".');var y=\"object\"===t(f)&&null!==f&&\"velocity\"in f?f.velocity:0;if(![0,1].includes(y))throw new Error(\"The velocity needs to be either 0 or 1.\");return(o=s.call(this))._buffer=a,o._position=x,o._timestamp=d,o._velocity=y,o}return o(i,[{key:\"process\",value:function(t,r){var o=e(t,1)[0],n=e(r,1)[0];if((null==o?void 0:o.length)>0){var u=e(o,1)[0];u.length>1&&(this._position=Math.round(u[0]),this._timestamp=Math.round(u[1]),this._velocity=Math.round(u[2]))}if(null!==this._buffer)for(var s=this._buffer.length,i=0;i<s;i+=1)for(var p=this._buffer[i],l=n[i],f=0;f<128;f+=1){var a=this._position+(currentFrame-this._timestamp+f)*this._velocity;a>=0&&a<p.length&&(l[f]=p[a])}return!0}}]),i}(i(AudioWorkletProcessor));f.parameterDescriptors=[],registerProcessor(\"timed-audio-buffer-source-node-audio-worklet-processor\",f)}(r(424),r(698),r(690),r(728),r(655),r(993),r(808),r(496))},897:e=>{e.exports=function(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,o=new Array(t);r<t;r++)o[r]=e[r];return o},e.exports.__esModule=!0,e.exports.default=e.exports},372:e=>{e.exports=function(e){if(Array.isArray(e))return e},e.exports.__esModule=!0,e.exports.default=e.exports},115:e=>{e.exports=function(e){if(void 0===e)throw new ReferenceError(\"this hasn't been initialised - super() hasn't been called\");return e},e.exports.__esModule=!0,e.exports.default=e.exports},690:e=>{e.exports=function(e,t){if(!(e instanceof t))throw new TypeError(\"Cannot call a class as a function\")},e.exports.__esModule=!0,e.exports.default=e.exports},515:(e,t,r)=>{var o=r(15),n=r(617);function u(t,r,s){return n()?(e.exports=u=Reflect.construct.bind(),e.exports.__esModule=!0,e.exports.default=e.exports):(e.exports=u=function(e,t,r){var n=[null];n.push.apply(n,t);var u=new(Function.bind.apply(e,n));return r&&o(u,r.prototype),u},e.exports.__esModule=!0,e.exports.default=e.exports),u.apply(null,arguments)}e.exports=u,e.exports.__esModule=!0,e.exports.default=e.exports},728:(e,t,r)=>{var o=r(62);function n(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,\"value\"in n&&(n.writable=!0),Object.defineProperty(e,o(n.key),n)}}e.exports=function(e,t,r){return t&&n(e.prototype,t),r&&n(e,r),Object.defineProperty(e,\"prototype\",{writable:!1}),e},e.exports.__esModule=!0,e.exports.default=e.exports},808:e=>{function t(r){return e.exports=t=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},655:(e,t,r)=>{var o=r(15);e.exports=function(e,t){if(\"function\"!=typeof t&&null!==t)throw new TypeError(\"Super expression must either be null or a function\");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,\"prototype\",{writable:!1}),t&&o(e,t)},e.exports.__esModule=!0,e.exports.default=e.exports},35:e=>{e.exports=function(e){try{return-1!==Function.toString.call(e).indexOf(\"[native code]\")}catch(t){return\"function\"==typeof e}},e.exports.__esModule=!0,e.exports.default=e.exports},617:e=>{e.exports=function(){if(\"undefined\"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if(\"function\"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}},e.exports.__esModule=!0,e.exports.default=e.exports},872:e=>{e.exports=function(e,t){var r=null==e?null:\"undefined\"!=typeof Symbol&&e[Symbol.iterator]||e[\"@@iterator\"];if(null!=r){var o,n,u,s,i=[],p=!0,l=!1;try{if(u=(r=r.call(e)).next,0===t){if(Object(r)!==r)return;p=!1}else for(;!(p=(o=u.call(r)).done)&&(i.push(o.value),i.length!==t);p=!0);}catch(e){l=!0,n=e}finally{try{if(!p&&null!=r.return&&(s=r.return(),Object(s)!==s))return}finally{if(l)throw n}}return i}},e.exports.__esModule=!0,e.exports.default=e.exports},218:e=>{e.exports=function(){throw new TypeError(\"Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\")},e.exports.__esModule=!0,e.exports.default=e.exports},993:(e,t,r)=>{var o=r(698).default,n=r(115);e.exports=function(e,t){if(t&&(\"object\"===o(t)||\"function\"==typeof t))return t;if(void 0!==t)throw new TypeError(\"Derived constructors may only return object or undefined\");return n(e)},e.exports.__esModule=!0,e.exports.default=e.exports},15:e=>{function t(r,o){return e.exports=t=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r,o)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},424:(e,t,r)=>{var o=r(372),n=r(872),u=r(116),s=r(218);e.exports=function(e,t){return o(e)||n(e,t)||u(e,t)||s()},e.exports.__esModule=!0,e.exports.default=e.exports},36:(e,t,r)=>{var o=r(698).default;e.exports=function(e,t){if(\"object\"!=o(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var n=r.call(e,t||\"default\");if(\"object\"!=o(n))return n;throw new TypeError(\"@@toPrimitive must return a primitive value.\")}return(\"string\"===t?String:Number)(e)},e.exports.__esModule=!0,e.exports.default=e.exports},62:(e,t,r)=>{var o=r(698).default,n=r(36);e.exports=function(e){var t=n(e,\"string\");return\"symbol\"==o(t)?t:String(t)},e.exports.__esModule=!0,e.exports.default=e.exports},698:e=>{function t(r){return e.exports=t=\"function\"==typeof Symbol&&\"symbol\"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&\"function\"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?\"symbol\":typeof e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},116:(e,t,r)=>{var o=r(897);e.exports=function(e,t){if(e){if(\"string\"==typeof e)return o(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return\"Object\"===r&&e.constructor&&(r=e.constructor.name),\"Map\"===r||\"Set\"===r?Array.from(e):\"Arguments\"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?o(e,t):void 0}},e.exports.__esModule=!0,e.exports.default=e.exports},496:(e,t,r)=>{var o=r(808),n=r(15),u=r(35),s=r(515);function i(t){var r=\"function\"==typeof Map?new Map:void 0;return e.exports=i=function(e){if(null===e||!u(e))return e;if(\"function\"!=typeof e)throw new TypeError(\"Super expression must either be null or a function\");if(void 0!==r){if(r.has(e))return r.get(e);r.set(e,t)}function t(){return s(e,arguments,o(this).constructor)}return t.prototype=Object.create(e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),n(t,e)},e.exports.__esModule=!0,e.exports.default=e.exports,i(t)}e.exports=i,e.exports.__esModule=!0,e.exports.default=e.exports}},t={};function r(o){var n=t[o];if(void 0!==n)return n.exports;var u=t[o]={exports:{}};return e[o].call(u.exports,u,u.exports,r),u.exports}r.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return r.d(t,{a:t}),t},r.d=(e,t)=>{for(var o in t)r.o(t,o)&&!r.o(e,o)&&Object.defineProperty(e,o,{enumerable:!0,get:t[o]})},r.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),(()=>{\"use strict\";r(31)})()})();"; // tslint:disable-line:max-line-length

    var blob = new Blob([worklet], {
      type: 'application/javascript; charset=utf-8'
    });
    var addTimedAudioBufferSourceNodeAudioWorkletModule = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(addAudioWorkletModule) {
        var url;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              url = URL.createObjectURL(blob);
              _context.prev = 1;
              _context.next = 4;
              return addAudioWorkletModule(url);
            case 4:
              _context.prev = 4;
              URL.revokeObjectURL(url);
              return _context.finish(4);
            case 7:
            case "end":
              return _context.stop();
          }
        }, _callee, null, [[1,, 4, 7]]);
      }));
      return function addTimedAudioBufferSourceNodeAudioWorkletModule(_x) {
        return _ref.apply(this, arguments);
      };
    }();
    var convertToContextFrame = createConvertToContextFrame(createPerformance());
    var subscribeToTimingObject = createSubscribeToTimingObject(createScheduleAudioBufferSourceNode(convertToContextFrame));
    function createTimedAudioBufferSourceNodeAudioWorkletNode(audioWorkletNodeConstructor, context, createAudioBufferSourceNode) {
      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
      var _a, _b;
      var _options$buffer = options.buffer,
        buffer = _options$buffer === void 0 ? null : _options$buffer;
      if (buffer instanceof AudioBuffer && buffer.sampleRate !== context.sampleRate) {
        throw new TypeError('The AudioBuffer must have the same sampleRate as the AudioContext.');
      }
      var _options$timingObject = options.timingObject,
        timingObject = _options$timingObject === void 0 ? null : _options$timingObject;
      var _ref2 = (_a = timingObject === null || timingObject === void 0 ? void 0 : timingObject.query()) !== null && _a !== void 0 ? _a : {},
        _ref2$position = _ref2.position,
        position = _ref2$position === void 0 ? 0 : _ref2$position,
        _ref2$timestamp = _ref2.timestamp,
        timestamp = _ref2$timestamp === void 0 ? 0 : _ref2$timestamp,
        _ref2$velocity = _ref2.velocity,
        velocity = _ref2$velocity === void 0 ? 0 : _ref2$velocity;
      var audioWorkletNode = new audioWorkletNodeConstructor(context, 'timed-audio-buffer-source-node-audio-worklet-processor', {
        numberOfInputs: 1,
        numberOfOutputs: 1,
        outputChannelCount: [(_b = buffer === null || buffer === void 0 ? void 0 : buffer.numberOfChannels) !== null && _b !== void 0 ? _b : 1],
        processorOptions: {
          buffer: buffer instanceof AudioBuffer ? Array.from({
            length: buffer.numberOfChannels
          }, function (_, channel) {
            return buffer.getChannelData(channel);
          }) : null,
          position: position,
          timestamp: convertToContextFrame(context, timestamp),
          velocity: velocity
        }
      });
      var removeListener = null;
      Object.defineProperties(audioWorkletNode, {
        port: {
          get: function get() {
            throw new Error("The port of a TimedAudioBufferSourceNodeAudioWorkletNode can't be accessed.");
          }
        },
        timingObject: {
          get: function get() {
            return timingObject;
          },
          set: function set(value) {
            removeListener === null || removeListener === void 0 ? void 0 : removeListener();
            removeListener = null;
            if (value === null) {
              timingObject = value;
            } else {
              throw new TypeError('A TimingObject can only be set in the constructor.');
            }
          }
        }
      });
      if (timingObject !== null) {
        removeListener = subscribeToTimingObject(audioWorkletNode, context, createAudioBufferSourceNode, timingObject);
      }
      return audioWorkletNode;
    }

    exports.addTimedAudioBufferSourceNodeAudioWorkletModule = addTimedAudioBufferSourceNodeAudioWorkletModule;
    exports.createTimedAudioBufferSourceNodeAudioWorkletNode = createTimedAudioBufferSourceNodeAudioWorkletNode;

}));
